#include <Servo.h>

Servo myservo;

int potPin = A0;      // analog pin connected to potentiometer
int potVal = 0;       // raw analog value
int delayVal = 0;     // mapped delay value
int pos = 0;          // current servo position
int direction = 1;    // 1 = forward, -1 = backward

void setup() {
  myservo.attach(3);  // attach the servo to pin 9
}

void loop() {
  potVal = analogRead(potPin);                   // Read pot value (0–1023)
  delayVal = map(potVal, 0, 1023, 1, 50);         // Map to delay range (smaller = faster)

  myservo.write(pos);                            // Move servo to current position
  pos += direction;                              // Step in current direction

  if (pos <= 0 || pos >= 90) {
    direction = -direction;                      // Reverse direction at ends
  }

  delay(delayVal);                               // Delay controls speed
}
